package info.bukova.isspst.services;

import info.bukova.isspst.filters.Filter;

import java.util.List;

public interface Service<T> {

	public void add(T entity);
	public void update(T entity);
	public void delete(T entity);
	public void validate(T entity) throws ValidationException;
	public List<T> getAll();
	public List<T> execQuery(String query);
	public T selectSingle(String query);
	public T getById(int id);
	public List<T> filterList(List<T> sourceList, Filter<T> filter);
	
}
