package info.bukova.isspst.ui;

import info.bukova.isspst.dao.IntegrityException;
import info.bukova.isspst.services.Service;
import info.bukova.isspst.services.ValidationException;

import java.util.Map;

import org.zkoss.bind.annotation.BindingParam;
import org.zkoss.bind.annotation.Command;
import org.zkoss.bind.annotation.ExecutionArgParam;
import org.zkoss.bind.annotation.Init;
import org.zkoss.bind.annotation.NotifyChange;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Window;

public class FormViewModel<T> {
	
	private T dataBean;
	private Map<String, String> errMessages;
	private Service<T> service;
	
	@Init
	public void init(@ExecutionArgParam("selected") T selected, @ExecutionArgParam("service") Service<T> service) {
		this.dataBean = selected;
		this.service = service;
	}
	
	public T getDataBean() {
		return dataBean;
	}
	
	@Command
	@NotifyChange("errMessages")
	public void save(@BindingParam("window") Window win) {
		try {
			service.update(dataBean);
			win.detach();
		} catch (ValidationException e) {
			errMessages = e.getMessages();
			String classErr = errMessages.get("CLASS_ERR");
			
			if (classErr == null) {
				classErr = "";
			}
			
			Messagebox.show("Chyba validace", "Error", Messagebox.OK, Messagebox.ERROR);
		} catch (IntegrityException e) {
			e.printStackTrace();
		}
	}

	public Map<String, String> getErrMessages() {
		return errMessages;
	}
	
	protected void setErrMesages(Map<String, String> msgs) {
		this.errMessages = msgs;
	}

}
